"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.handler = exports.builder = exports.desc = exports.command = void 0;
var helpers_1 = require("../../../helpers");
// tslint:disable-next-line: no-var-requires
var logger = helpers_1.createNewLogger('codefresh:get:file');
exports.command = 'file';
exports.desc = 'Fetch a raw file from a git repository';
exports.builder = function (yargs) { return yargs
    .usage('Usage: $0 get file [options]')
    .option('owner', {
    alias: 'o',
    demandOption: helpers_1.errormsg(templateObject_1 || (templateObject_1 = __makeTemplateObject(["must provide \"owner\" option"], ["must provide \"owner\" option"]))),
    describe: 'The name of the owner of the git repository',
    type: 'string'
})
    .option('repo', {
    alias: 'r',
    demandOption: helpers_1.errormsg(templateObject_2 || (templateObject_2 = __makeTemplateObject(["must provide \"repo\" option"], ["must provide \"repo\" option"]))),
    describe: 'The name of the git repository',
    type: 'string'
})
    .option('revision', {
    alias: ['ref', 'v'],
    describe: 'The revision of the file',
    type: 'string',
    "default": 'master'
})
    .option('path', {
    alias: 'p',
    demandOption: helpers_1.errormsg(templateObject_3 || (templateObject_3 = __makeTemplateObject(["must provide \"path\" option"], ["must provide \"path\" option"]))),
    describe: 'The path to the file that needs to be fetched',
    type: 'string'
})
    .example("$0 get " + exports.command + " -o some-owner -r some-repo -p ./path/to/file", 'Will fetch the file located at path/to/file from the root of repo: "some-owner/some-repo" (revision "master")')
    .example("$0 get " + exports.command + " -o some-owner -r some-repo -p ./path/to/file -v some-rev ", 'Will fetch the file located at path/to/file from the root of repo: "some-owner/some-repo" revision "some-rev"')
    .example("$0 get " + exports.command + " -o some-owner -r some-repo -p ./path/to/file -s output.txt", 'Will fetch the file located at path/to/file from the root of repo: "some-owner/some-repo" and save the contents to "output.txt"'); };
exports.handler = function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var owner, repo, path, revision, provider, output, _a, fetchFileErr, file;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                owner = argv.owner;
                repo = argv.repo;
                path = argv.path;
                revision = argv.revision;
                provider = argv.provider;
                output = argv.output;
                logger.debug("owner=" + owner);
                logger.debug("repo=" + repo);
                logger.debug("path=" + path);
                logger.debug("revision=" + revision);
                logger.debug("output=" + output);
                return [4 /*yield*/, helpers_1.to(provider.fetchRawFile({ owner: owner, repo: repo, ref: revision, path: path }))];
            case 1:
                _a = _b.sent(), fetchFileErr = _a[0], file = _a[1];
                if (fetchFileErr) {
                    helpers_1.exitWithError("failed to fetch file \"" + path + "\", " + fetchFileErr);
                }
                if (!output) return [3 /*break*/, 3];
                return [4 /*yield*/, helpers_1.writeResultsToFile(output, file)];
            case 2:
                _b.sent();
                return [3 /*break*/, 4];
            case 3:
                console.log(file);
                _b.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=file.cmd.js.map