"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.handler = exports.builder = exports.desc = exports.aliases = exports.command = void 0;
var helpers_1 = require("../../../helpers");
// tslint:disable-next-line: no-var-requires
var logger = helpers_1.createNewLogger('codefresh:list:repos');
exports.command = 'repos';
exports.aliases = ['rp'];
exports.desc = 'Get a list of repos of a specified owner';
exports.builder = function (yargs) { return yargs
    .usage('Usage: $0 list repos [options]')
    .option('owner', {
    alias: 'o',
    demandOption: helpers_1.errormsg(templateObject_1 || (templateObject_1 = __makeTemplateObject(["must provide \"owner\" option"], ["must provide \"owner\" option"]))),
    describe: 'The name of the owner of the git repository',
    type: 'string'
})
    .example("$0 list " + exports.command + " -o some-owner", 'Will list all the repositories of "some-owner"')
    .example("$0 list " + exports.command + " -o some-owner -l 40", 'Will list up to 40 repositories of "some-owner"'); };
exports.handler = function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var owner, provider, output, limit, _a, listReposErr, repos, repoNames;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                owner = argv.owner;
                provider = argv.provider;
                output = argv.output;
                limit = argv.limit;
                logger.debug("owner=" + owner);
                logger.debug("output=" + output);
                logger.debug("limit=" + limit);
                return [4 /*yield*/, helpers_1.to(provider.listRepositories({ owner: owner, limit: limit }))];
            case 1:
                _a = _b.sent(), listReposErr = _a[0], repos = _a[1];
                if (listReposErr) {
                    helpers_1.exitWithError("failed to get the list of repositories of \"" + owner + "\", " + listReposErr);
                }
                repoNames = repos.map(function (r) { return r.full_name; });
                if (!output) return [3 /*break*/, 3];
                return [4 /*yield*/, helpers_1.writeResultsToFile(output, JSON.stringify(repoNames))];
            case 2:
                _b.sent();
                return [3 /*break*/, 4];
            case 3:
                console.log(JSON.stringify(repoNames));
                _b.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
var templateObject_1;
//# sourceMappingURL=repos.cmd.js.map