"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.writeResultsToFile = exports.createNewLogger = exports.parseGitContext = exports.exitWithError = exports.errormsg = exports.to = void 0;
var chalk_1 = require("chalk");
var debug_1 = __importDefault(require("debug"));
var fs_1 = require("fs");
exports.to = function (fn) { return __awaiter(void 0, void 0, void 0, function () {
    var res, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 5, , 6]);
                res = void 0;
                if (!(typeof fn === 'function')) return [3 /*break*/, 2];
                return [4 /*yield*/, fn()];
            case 1:
                res = _a.sent();
                return [3 /*break*/, 4];
            case 2: return [4 /*yield*/, fn];
            case 3:
                res = _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/, [null, res]];
            case 5:
                err_1 = _a.sent();
                return [2 /*return*/, [err_1, null]];
            case 6: return [2 /*return*/];
        }
    });
}); };
exports.errormsg = function (msg) {
    return chalk_1.red(templateObject_1 || (templateObject_1 = __makeTemplateObject(["error: "], ["error: "]))) + msg;
};
exports.exitWithError = function (msg) {
    console.log(exports.errormsg(msg));
    process.exit(1);
};
exports.parseGitContext = function (gitContextStr) {
    var isBase64 = /^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)?$/;
    if (isBase64.test(gitContextStr)) {
        gitContextStr = Buffer.from(gitContextStr, 'base64').toString('utf-8');
    }
    try {
        var gitContext = JSON.parse(gitContextStr);
        return gitContext;
    }
    catch (err) {
        exports.exitWithError("could not parse git context json, with error " + err);
    }
};
exports.createNewLogger = function (namespace) {
    var logger = debug_1["default"](namespace);
    return {
        info: function (msg) { return logger("level: %s, msg: %s", 'info', msg); },
        warn: function (msg) { return logger("level: %s, msg: %s", 'warn', msg); },
        debug: function (msg) { return logger("level: %s, msg: %s", 'debug', msg); },
        error: function (msg) { return logger("level: %s, msg: %s", 'error', msg); }
    };
};
exports.writeResultsToFile = function (fileName, data) { return __awaiter(void 0, void 0, void 0, function () {
    var writeErr;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.to(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/, fs_1.writeFileSync(fileName, data)];
                }); }); })];
            case 1:
                writeErr = (_a.sent())[0];
                if (writeErr) {
                    exports.exitWithError("failed to write result to file " + fileName + "\", " + writeErr);
                }
                return [2 /*return*/];
        }
    });
}); };
var templateObject_1;
//# sourceMappingURL=index.js.map