"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.getProviderByContext = void 0;
var lodash_1 = require("lodash");
// tslint:disable-next-line no-var-requires
var CFError = require('cf-errors');
// Providers
var github_1 = __importDefault(require("./providers/github"));
var gitlab_1 = __importDefault(require("./providers/gitlab"));
var bitbucket_1 = __importDefault(require("./providers/bitbucket"));
var bitbucket_server_1 = __importDefault(require("./providers/bitbucket-server"));
var providers = {
    'github': github_1["default"],
    'gitlab': gitlab_1["default"],
    'bitbucket': bitbucket_1["default"],
    'bitbucket-server': bitbucket_server_1["default"]
};
var _getProviderModule = function (providerName) {
    var providerModule = providers[providerName];
    if (!providerModule) {
        throw new CFError("Provider module cannot be found: " + providerName);
    }
    return providerModule;
};
function getProviderByContext(gitContext) {
    return __awaiter(this, void 0, void 0, function () {
        var providerName, providerOptions, ProviderClass;
        return __generator(this, function (_a) {
            providerName = gitContext.spec.type.replace('git.', '');
            providerOptions = lodash_1.get(gitContext, 'spec.data.auth', {});
            ProviderClass = _getProviderModule(providerName);
            return [2 /*return*/, new ProviderClass(providerOptions)];
        });
    });
}
exports.getProviderByContext = getProviderByContext;
__exportStar(require("./providers/types"), exports);
//# sourceMappingURL=index.js.map