import { Provider, Repository, Branch, Webhook } from './types';
export default class BitbucketServer implements Provider {
    private baseUrl;
    private authenticationHeader;
    private timeout;
    constructor(opts: {
        password: string;
        username?: string;
        type: 'basic' | 'oauth2' | 'PAT';
        apiURL?: string;
        timeout?: number;
    });
    private performAPICall;
    fetchRawFile(opts: {
        owner: string;
        repo: string;
        ref: string;
        path: string;
    }): Promise<string>;
    getBranch(opts: {
        owner: string;
        repo: string;
        branch: string;
    }): Promise<Branch>;
    listBranches(opt: {
        owner: string;
        repo: string;
        limit?: number | undefined;
    }): Promise<Branch[]>;
    listRepositories(opt: {
        owner: string;
        limit?: number | undefined;
    }): Promise<Repository[]>;
    createRepositoryWebhook(opt: {
        owner: string;
        repo: string;
        endpoint: string;
        secret: string;
    }): Promise<Webhook>;
    listWebhooks(opt: {
        owner: string;
        repo: string;
        limit?: number;
    }): Promise<Webhook[]>;
}
