import { Provider, Branch, Repository, Webhook } from './types';
export default class Github implements Provider {
    private githubClient;
    constructor(opt: {
        password: string;
        apiPathPrefix?: string;
        apiHost?: string;
        timeout?: number;
    });
    private getLimitedResults;
    fetchRawFile(opt: {
        owner: string;
        repo: string;
        ref: string;
        path: string;
    }): Promise<string>;
    getBranch(opt: {
        owner: string;
        repo: string;
        branch: string;
    }): Promise<Branch>;
    listBranches(opt: {
        owner: string;
        repo: string;
        limit?: number;
    }): Promise<Branch[]>;
    listRepositories(opt: {
        owner: string;
        limit?: number | undefined;
    }): Promise<Repository[]>;
    listWebhooks(opt: {
        owner: string;
        repo: string;
        limit?: number;
    }): Promise<Webhook[]>;
    createRepositoryWebhook(opt: {
        owner: string;
        repo: string;
        endpoint: string;
        secret: string;
    }): Promise<Webhook>;
}
