"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var rest_1 = require("@octokit/rest");
var helpers_1 = require("../helpers");
var lodash_1 = require("lodash");
// tslint:disable-next-line: no-var-requires
var CFError = require('cf-errors');
var logger = helpers_1.createNewLogger('codefresh:infra:git-providers:github');
var _cleanFilePath = function (filepath) {
    var prefix = './';
    var hasPrefix = filepath.indexOf(prefix) === 0;
    var path = hasPrefix ? filepath.substring(prefix.length) : filepath;
    return path;
};
var _toBranch = function (rawBranch) {
    return {
        id: rawBranch.name,
        name: rawBranch.name,
        commit: {
            sha: lodash_1.get(rawBranch, 'commit.sha'),
            commiter_name: lodash_1.get(rawBranch, 'commit.commit.author.name', ''),
            message: lodash_1.get(rawBranch, 'commit.commit.message', ''),
            url: lodash_1.get(rawBranch, 'commit.commit.url', '')
        }
    };
};
var _toRepo = function (rawRepo) {
    return {
        id: rawRepo.id,
        name: rawRepo.name,
        full_name: rawRepo.full_name,
        description: lodash_1.get(rawRepo, 'description', ''),
        owner: lodash_1.get(rawRepo, 'owner.login', ''),
        url: lodash_1.get(rawRepo, 'html_url', '')
    };
};
var _toWebhook = function (rawWebhook) {
    return {
        id: rawWebhook.id,
        name: rawWebhook.name,
        events: rawWebhook.events,
        endpoint: rawWebhook.config.url
    };
};
var Github = /** @class */ (function () {
    function Github(opt) {
        var pathPrefix = (opt.apiPathPrefix && opt.apiPathPrefix !== '/') ? opt.apiPathPrefix : '';
        this.githubClient = new rest_1.Octokit({
            userAgent: 'Codefresh',
            auth: opt.password,
            request: {
                timeout: opt.timeout || 10000
            },
            timeout: opt.timeout || 10000,
            host: opt.apiHost || 'api.github.com',
            log: logger,
            debug: true,
            baseUrl: "https://" + (opt.apiHost || 'api.github.com') + pathPrefix
        });
    }
    Github.prototype.getLimitedResults = function (apiFunc, args, limit) {
        return __awaiter(this, void 0, void 0, function () {
            var finalResults, MAX_PER_PAGE, page, neededResults, _a, err, results;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        finalResults = [];
                        MAX_PER_PAGE = 100;
                        page = 1;
                        _b.label = 1;
                    case 1:
                        if (!(finalResults.length < limit)) return [3 /*break*/, 3];
                        neededResults = limit - finalResults.length;
                        return [4 /*yield*/, helpers_1.to(apiFunc(__assign(__assign({}, args), { page: page, per_page: MAX_PER_PAGE })))];
                    case 2:
                        _a = _b.sent(), err = _a[0], results = _a[1];
                        if (err) {
                            throw err;
                        }
                        finalResults.push.apply(finalResults, results.data.slice(0, neededResults));
                        page += 1;
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/, {
                            data: finalResults,
                            status: 200
                        }];
                }
            });
        });
    };
    Github.prototype.fetchRawFile = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, repo, ref, path, _a, err, res, data, base64Content;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        owner = opt.owner, repo = opt.repo, ref = opt.ref, path = opt.path;
                        return [4 /*yield*/, helpers_1.to(this.githubClient.repos.getContent({ owner: owner, repo: repo, path: _cleanFilePath(path), ref: ref }))];
                    case 1:
                        _a = _b.sent(), err = _a[0], res = _a[1];
                        if (err) {
                            throw new CFError({
                                message: "Failed to retrieve file: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to retrieve file: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        data = res.data;
                        base64Content = data.content.replace(/\n/ig, '');
                        return [2 /*return*/, Buffer.from(base64Content, 'base64').toString()];
                }
            });
        });
    };
    Github.prototype.getBranch = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, helpers_1.to(this.githubClient.repos.getBranch(opt))];
                    case 1:
                        _a = _b.sent(), err = _a[0], res = _a[1];
                        if (err) {
                            throw new CFError({
                                message: "Failed to retrieve branch: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to retrieve branch: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, _toBranch(res.data)];
                }
            });
        });
    };
    Github.prototype.listBranches = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, repo, limit, err, res;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        owner = opt.owner, repo = opt.repo, limit = opt.limit;
                        if (!limit) return [3 /*break*/, 2];
                        return [4 /*yield*/, helpers_1.to(this.getLimitedResults(this.githubClient.repos.listBranches, { owner: owner, repo: repo }, limit))];
                    case 1:
                        (_a = _c.sent(), err = _a[0], res = _a[1]);
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, helpers_1.to(this.githubClient.paginate("GET /repos/:owner/:repo/branches", {
                            owner: owner,
                            repo: repo
                        }))];
                    case 3:
                        (_b = _c.sent(), err = _b[0], res = _b[1]);
                        res = {
                            status: 200,
                            data: res
                        };
                        _c.label = 4;
                    case 4:
                        if (err) {
                            throw new CFError({
                                message: "Failed to list branches: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to list branches: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, res.data.map(_toBranch)];
                }
            });
        });
    };
    Github.prototype.listRepositories = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, limit, err, res;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        owner = opt.owner, limit = opt.limit;
                        if (!limit) return [3 /*break*/, 2];
                        return [4 /*yield*/, helpers_1.to(this.getLimitedResults(this.githubClient.repos.listForUser, { username: owner }, limit))];
                    case 1:
                        (_a = _c.sent(), err = _a[0], res = _a[1]);
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, helpers_1.to(this.githubClient.paginate("GET /users/:owner/repos", {
                            owner: owner
                        }))];
                    case 3:
                        (_b = _c.sent(), err = _b[0], res = _b[1]);
                        res = {
                            status: 200,
                            data: res
                        };
                        _c.label = 4;
                    case 4:
                        if (err) {
                            throw new CFError({
                                message: "Failed to list repos: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to list repos: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, res.data.map(_toRepo)];
                }
            });
        });
    };
    Github.prototype.listWebhooks = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, repo, limit, err, res;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        owner = opt.owner, repo = opt.repo, limit = opt.limit;
                        if (!limit) return [3 /*break*/, 2];
                        return [4 /*yield*/, helpers_1.to(this.getLimitedResults(this.githubClient.repos.listWebhooks, { owner: owner, repo: repo }, limit))];
                    case 1:
                        (_a = _c.sent(), err = _a[0], res = _a[1]);
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, helpers_1.to(this.githubClient.paginate("GET /repos/:owner/:repo/hooks", {
                            owner: owner,
                            repo: repo
                        }))];
                    case 3:
                        (_b = _c.sent(), err = _b[0], res = _b[1]);
                        res = {
                            status: 200,
                            data: res
                        };
                        _c.label = 4;
                    case 4:
                        if (err) {
                            throw new CFError({
                                message: "Failed to list repository webhooks: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to list repository webhooks: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, res.data.map(_toWebhook)];
                }
            });
        });
    };
    Github.prototype.createRepositoryWebhook = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, repo, endpoint, secret, _a, err, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        owner = opt.owner, repo = opt.repo, endpoint = opt.endpoint, secret = opt.secret;
                        return [4 /*yield*/, helpers_1.to(this.githubClient.repos.createWebhook({
                                owner: owner,
                                repo: repo,
                                name: 'web',
                                config: {
                                    url: endpoint,
                                    content_type: 'json',
                                    secret: secret
                                },
                                events: [
                                    'push',
                                    'pull_request',
                                    'release',
                                    'issue_comment',
                                    'repository'
                                ],
                                active: true
                            }))];
                    case 1:
                        _a = _b.sent(), err = _a[0], res = _a[1];
                        if (err) {
                            throw new CFError({
                                message: "Failed to create repository webhook: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to create repository webhook: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, _toWebhook(res.data)];
                }
            });
        });
    };
    return Github;
}());
exports["default"] = Github;
//# sourceMappingURL=github.js.map